#include <sys/ptrace.h>
#include <asm/ptrace.h>
#include <sys/wait.h>
#include <assert.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int
main ()
{
  int status;
  pid_t pid;
  long l;
  siginfo_t info;
  long a = -12345;

  switch (fork ())
    {
    case 0:
      ptrace (PTRACE_TRACEME);
      raise (SIGUSR1);
      execl ("/bin/echo", "echo", "hello world", (char *) 0);
      _exit (127);

    case -1:
      perror ("fork");
      return 2;
    }

  pid = waitpid (WAIT_ANY, &status, WUNTRACED);
  printf ("%d %#x\n", pid, status);
  assert (WIFSTOPPED (status));
  assert (WSTOPSIG (status) == SIGUSR1);

  l = ptrace (PTRACE_SETOPTIONS, pid, 0, PTRACE_O_TRACESYSGOOD);
  assert (l == 0);

  do
    {
      l = ptrace (PTRACE_SYSCALL, pid, 0, 0);
      if (l)
	{
	  perror ("ptrace");
	  return 1;
	}

      pid = waitpid (WAIT_ANY, &status, WUNTRACED);
      printf ("%d %#x\n", pid, status);

      l = ptrace (PTRACE_GETSIGINFO, pid, 0, &info);
      if (l)
	perror ("PTRACE_GETSIGINFO");
      else
	printf ("\t%d %#x\n", info.si_signo, info.si_code);
      errno = 0;
      l = ptrace (PTRACE_PEEKUSER, pid, 120, &a);
      if (errno)
	perror ("PTRACE_PEEKUSER");
      else
	printf ("\t%ld\n", l);
    }
  while (WIFSTOPPED (status));

  return 0;
}
